<template>
  <div class="app-container">
    <TableSearch
        :queryParams="queryParams"
        queryRef="queryRef"
        :showSearch="showSearch"
        @search="handleQuery"
        @refresh="resetQuery"
    >
      <template #one>
        <el-col :xs="24" :sm="24" :md="12" :lg="6" :xl="6" :xxl="6">
          <el-form-item label="分组名称" prop="groupName">
            <el-input
                v-model="queryParams.groupName"
                placeholder="请输入分组名称"
                style="width:100%"
                clearable
                @keyup.enter="handleQuery"
            />
          </el-form-item>
        </el-col>
        <el-col :xs="24" :sm="24" :md="12" :lg="6" :xl="6" :xxl="6">
          <el-form-item label="分组描述" prop="desc">
            <el-input
                v-model="queryParams.desc"
                placeholder="请输入分组描述"
                style="width:100%"
                clearable
                @keyup.enter="handleQuery"
            />
          </el-form-item>
        </el-col>
      </template>
    </TableSearch>
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
            type="primary"
            plain
            icon="Plus"
            @click="handleAdd"
            v-hasPermi="['system:group:add']"
        >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            type="success"
            plain
            icon="Edit"
            :disabled="single"
            @click="handleUpdate"
            v-hasPermi="['system:group:edit']"
        >修改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            type="danger"
            plain
            icon="Delete"
            :disabled="multiple"
            @click="handleDelete"
            v-hasPermi="['system:group:remove']"
        >删除
        </el-button>
      </el-col>
      <!--      <el-col :span="1.5">-->
      <!--        <el-button-->
      <!--          type="warning"-->
      <!--          plain-->
      <!--          icon="Download"-->
      <!--          @click="handleExport"-->
      <!--          v-hasPermi="['system:group:export']"-->
      <!--        >导出</el-button>-->
      <!--      </el-col>-->
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="groupList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="分组ID" align="center" prop="groupId"/>
      <el-table-column label="分组类型" align="center" prop="type">
        <template #default="scope">
          {{ sys_group_type?.find(item => Number(item.value) === scope.row.type)["label"] }}
        </template>
      </el-table-column>
      <el-table-column label="分组名称" align="center" prop="groupName"/>
      <el-table-column label="分组描述" align="center" prop="desc"/>
      <el-table-column show-overflow-tooltip label="备注" align="center" prop="remark"/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['system:group:edit']">修改
          </el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['system:group:remove']">删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
        v-show="total>0"
        :total="total"
        v-model:page="queryParams.pageNum"
        v-model:limit="queryParams.pageSize"
        @pagination="getList"
    />

    <!-- 添加或修改通用分组配置对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="groupRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="分组名称" prop="groupName">
          <el-input v-model="form.groupName" placeholder="请输入分组名称"/>
        </el-form-item>
        <el-form-item label="分组类型">
          <el-select v-model="form.type" placeholder="请选择分组类型">
            <el-option v-for="dict in sys_group_type" :key="dict.value" :label="dict.label"
                       :value="Number(dict.value)"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="分组描述" prop="desc">
          <el-input v-model="form.desc" placeholder="请输入分组描述"/>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容"/>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Group">
import {listGroup, getGroup, delGroup, addGroup, updateGroup} from "@/api/system/group"
import TableSearch from "@/components/TableSearch/index.vue"
import {controlModuleList} from "@/enum/index.js";

const {proxy} = getCurrentInstance()
const {sys_group_type} = proxy.useDict("sys_group_type");

const groupList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    type: null,
    groupName: null,
    desc: null,
  },
  rules: {
    type: [
      {required: true, message: "分组类型不能为空", trigger: "change"}
    ],
    groupName: [
      {required: true, message: "分组名称不能为空", trigger: "blur"}
    ],
  }
})

const {queryParams, form, rules} = toRefs(data)

/** 查询通用分组配置列表 */
function getList() {
  loading.value = true
  listGroup(queryParams.value).then(response => {
    groupList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    // groupId: null,
    // type: null,
    // groupName: null,
    // desc: null,
    // createBy: null,
    // createTime: null,
    // updateBy: null,
    // updateTime: null,
    // remark: null
  }
  proxy.resetForm("groupRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.groupId)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加通用分组配置"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _groupId = row.groupId || ids.value
  getGroup(_groupId).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改通用分组配置"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["groupRef"].validate(valid => {
    if (valid) {
      if (form.value.groupId != null) {
        updateGroup(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addGroup(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _groupIds = row.groupId || ids.value
  proxy.$modal.confirm('是否确认删除通用分组配置编号为"' + _groupIds + '"的数据项？').then(function () {
    return delGroup(_groupIds)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => {
  })
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('system/group/export', {
    ...queryParams.value
  }, `group_${new Date().getTime()}.xlsx`)
}

getList()
</script>
